import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.sql.Time;
import java.util.Arrays;
import java.util.Date;
import java.util.Properties;

import javax.mail.Address;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Part;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Transport;
import javax.mail.URLName;
import javax.mail.Message.RecipientType;
import javax.mail.internet.AddressException;
import javax.mail.internet.ContentType;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet implementation class WebMail
 */
public class WebMail extends HttpServlet {
    private static final long serialVersionUID = 1L;

    /**
     * @see HttpServlet#HttpServlet()
     */
    public WebMail() {
	super();
	// TODO Auto-generated constructor stub
    }

    /**
     * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
     *      response)
     */
    protected void doGet(HttpServletRequest request,
	    HttpServletResponse response) throws ServletException, IOException {
	HttpSession registeredSession = request.getSession(true);
	registeredSession.setMaxInactiveInterval(1000000);
	response.setCharacterEncoding("UTF-8");
	response.setContentType("text/html; charset=UTF-8");
	PrintWriter out = response.getWriter();

	String userName = null;
	String userPassword = null;
	if (registeredSession.getAttribute("userName") != null) {
	    userName = (String) registeredSession.getAttribute("userName");
	    userPassword = (String) registeredSession
		    .getAttribute("userPassword");
	} else {
	    registeredSession.invalidate();
	    response.sendRedirect(response.encodeRedirectURL("/Webmail"));
	}

	String userAddress = userName + "@gmail.com";
	Store registeredStore;

	if (registeredSession.isNew()) {
	    System.err.println("Vytvaram sedenie...");
	    String host = "imap.gmail.com";
	    String user = userName;
	    String password = userPassword;

	    URLName url = new URLName("imaps", host, -1, "INBOX", user,
		    password);

	    Properties props = System.getProperties();
	    props.put("mail.mime.charset", "utf-8");
	    Session session = Session.getDefaultInstance(props, null);
	    session.setDebug(false);
	    Store store = null;
	    try {
		store = session.getStore(url);
		store.close();
		if (!store.isConnected())
		    store.connect();
	    } catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    } finally {
		if (store == null)
		    throw new ServletException("Chyba v spojeni");
		else
		    registeredSession.setAttribute("store", store);
		registeredStore = store;
	    }
	} else {
	    System.err.println("Vyberam zo session...");
	    registeredStore = (Store) registeredSession.getAttribute("store");
	}
	/* -------------------- Logout -------------------- */
	if (request.getParameter("logout") != null) {
	    try {
		registeredStore.close();
	    } catch (MessagingException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	    registeredSession.invalidate();
	    response.sendRedirect(response.encodeRedirectURL("/Webmail"));
	    /* ------ Zaciatok vypisov na stranke ------ */
	} else {
	    printHeader(out);
	    out.print("<div class=\"topPanel\"><b> Logged in @");
	    out.print(new Time(registeredSession.getCreationTime()).toString());
	    out
		    .print("</b> | "
			    + userAddress
			    + " | <a href=\"?compose=null\">Compose new message</a> | <a href=\"?logout=true\">Logout</a>");
	    out.print("</div>");
	    try {
		if (registeredStore == null) {
		    registeredSession.invalidate();
		    response
			    .sendRedirect(response.encodeRedirectURL("WebMail"));
		    System.err.println("Connection renewed");
		} else {
		    /* ------------- Napisanie novej spravy ---------------- */
		    if (request.getParameter("compose") != null) {
			String recepient = request.getParameter("compose");
			if (recepient.equals("null"))
			    recepient = "";
			// vykreslenie formulara
			out.print("<div class=\"messageBox\">");
			out.print("<form method=\"post\" action=\"?\" >");
			out
				.print("<table><tr><td>To: </td><td><input type=\"text\" style=\"width:200px;\" name=\"recepient\" value=\""
					+ recepient + "\"/></td></tr>");
			out
				.print("<tr><td>Subject: </td><td><input type=\"text\" style=\"width:200px;\" name=\"subject\" /></td></tr>");
			out
				.print("<tr><td style=\"vertical-align:top\">Text: </td><td><textarea style=\"width: 500px; height:500px;\" name=\"text\"></textarea></td></tr>");
			out
				.print("<tr><td></td><td><input type=\"submit\" value=\"Submit\" name=\"submit\"/>");
			out
				.print("<input type=\"reset\" value=\"Reset\" name=\"reset\"/>");
			out
				.print("<input type=\"submit\" value=\"Close\" name=\"close\"/></td></tr></table>");
			out.print("</form>");
			out.print("</div>");
		    }
		    /* ------------- Vypisat zoznam priecinkov ------------- */
		    // ak nebol zvoleny ziadny priecinok vezmeme default alebo
		    // INBOX
		    if (!registeredStore.isConnected())
			registeredStore.connect();
		    Folder f = registeredStore.getDefaultFolder();
		    if (f == null)
			f = registeredStore.getFolder("INBOX");
		    out.print("<div class=\"folderList\">");
		    if (f.getFullName().equals("") || f.getFullName() == null)
			out.print("<span class=\"folderHeading\">" + userName
				+ "'s folders</span>");
		    else
			out.print("<span class=\"folderHeading\">"
				+ f.getFullName() + "'s folders</span>");
		    if (registeredSession.getAttribute("folderList") != null) {
			out.print(registeredSession.getAttribute("folderList"));
		    } else {
			StringBuilder sb = new StringBuilder();
			out.print(printFolders(sb, f));
			registeredSession.setAttribute("folderList", sb
				.toString());
		    }
		    out.print("</div>");
		    // ak bol zvoleny priecinok vypisujeme jeho obsah
		    if (request.getParameter("folder") != null) {
			f = registeredStore.getFolder(request
				.getParameter("folder"));
		    } else {
			f = registeredStore.getFolder("INBOX");
		    }
		    /* ------------- Vypisat zvolenu spravu ----------------- */
		    if (request.getParameter("viewMessage") != null
			    && request.getParameter("folder") != null) {
			int messageNumber = Integer.parseInt(request
				.getParameter("viewMessage"));
			if (!f.isOpen())
			    f.open(Folder.READ_ONLY);
			Message message = f.getMessage(messageNumber);
			out.print("<div class=\"messageBox\">");
			out.print("<h1>" + message.getSubject() + "</h1>");
			Address[] a = (Address[]) message.getFrom();
			StringBuilder sb = new StringBuilder();
			for (int j = 0; j < a.length; j++) {
			    sb.append(((InternetAddress) a[j]).getAddress());
			    sb.append("; ");
			}
			out.print("<p>From: " + sb.toString() + "</p>");
			Address[] b = message.getAllRecipients();
			sb = new StringBuilder();
			for (int j = 0; j < b.length; j++) {
			    sb.append(((InternetAddress) b[j]).getAddress());
			    sb.append("; ");
			}
			out.print("<p>To: " + sb.toString() + "</p>");
			out.print("<p>Date / Time: " + message.getSentDate()
				+ "</p>");
			out.print("<p>");
			// A teraz vypisat obsah spravy podla jej obsahu
			Object content = message.getContent();
			if (content instanceof String) {
			    out.println("<pre>");
			    out.println((String) content);
			    out.println("</pre>");
			} else if (content instanceof Multipart) {
			    Multipart mp = (Multipart) content;
			    printMultipartMessage(f.getName(), messageNumber,
				    mp, out);
			} else {
			    out.println(message.getContentType());
			}
			out.print("</p>");
			out.print("<a href=\"?\">Close window</a>");
			out.print("</div>");
		    }
		    /* ------------- Zobrazit prilohy ----------------------- */
		    if (request.getParameter("message") != null
			    && request.getParameter("part") != null
			    && request.getParameter("folder") != null) {
			if (!f.isOpen())
			    f.open(Folder.READ_ONLY);
			Message msg = f.getMessage(Integer.parseInt(request
				.getParameter("message")));
			Multipart mp = (Multipart) msg.getContent();
			Part part = mp.getBodyPart(Integer.parseInt(request
				.getParameter("part")));

			String sct = part.getContentType();
			if (sct == null) {
			    out.println("invalid part");
			} else {
			    ContentType ct = new ContentType(sct);
			    response.setContentType(ct.getBaseType());
			    response.setContentLength(part.getSize());
			    InputStream is = part.getInputStream();
			    int i;
			    while ((i = is.read()) != -1)
				out.write(i);
			    out.flush();
			}
		    }
		    /* ------------- Vypisat spravy ------------------------- */
		    if ((f.getType() & Folder.HOLDS_MESSAGES) != 0) {
			if (!f.isOpen())
			    f.open(Folder.READ_ONLY);
			int msgCount = f.getMessageCount();
			if (msgCount == 0)
			    out
				    .print("<div class=\"messagesList\">No messages</div>");
			else {
			    int msgPage = msgCount;
			    if (request.getParameter("msgPage") != null)
				msgPage = Integer.parseInt(request
					.getParameter("msgPage"));
			    Message[] m = null;
			    if (msgCount > 30)
				m = f.getMessages(msgPage - 30, msgPage);
			    else
				m = f.getMessages(1, msgPage);
			    out.print("<div class=\"messagesList\">");
			    out.print("<div class=\"navigation\">");
			    if (msgCount > 30) {
				if (msgPage != msgCount) {
				    out
					    .print("<a href=\"?msgPage="
						    + (msgPage + 30)
						    + "\">&lt;&lt;&lt; Previous page</a> | ");
				}
				out.print("<a href=\"?msgPage="
					+ (msgPage - 30)
					+ "\">Next page &gt;&gt;&gt;</a>");
			    }
			    out.print("</div>");
			    out.print("<table id=\"hor-zebra\">");
			    out.print("<thead>");
			    out.print("<tr>");
			    out.print("<th>#</th>");
			    out.print("<th>From</th>");
			    out.print("<th>Subject</th>");
			    out.print("<th>Date / Time</th>");
			    out.print("</tr>");
			    out.print("</thead>");
			    out.print("<tbody>");
			    for (int i = m.length - 1; i > 0; i--) {
				if (i % 2 == 0) {
				    out.print("<tr class=\"odd\">");
				} else {
				    out.print("<tr>");
				}
				out.print("<td>" + m[i].getMessageNumber()
					+ "</td>");
				InternetAddress[] a = (InternetAddress[]) m[i]
					.getFrom();
				StringBuilder sb = new StringBuilder();
				for (int j = 0; j < a.length; j++) {
				    sb.append("<a href=\"?compose=");
				    sb.append(a[j].getAddress());
				    sb.append("\">");
				    sb.append(a[j].getAddress());
				    sb.append("</a>");
				}
				out.print("<td>" + sb.toString() + "</td>");
				out.print("<td><a href=\"?viewMessage="
					+ m[i].getMessageNumber()
					+ "&amp;folder=" + f.getFullName()
					+ "\">" + m[i].getSubject()
					+ "</a></td>");
				out.print("<td>" + m[i].getReceivedDate()
					+ "</td>");
				out.print("</tr>");
				if (i > 30)
				    break;
			    }
			    out.print("</tbody>");
			    out.print("</table>");
			    out.print("</div>");
			}
		    } else {
			out.print("<div class=\"messagesList\">");
			out.print("Choose a different folder");
			out.print("</div>");
		    }
		}
	    } catch (MessagingException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	    printFooter(out);
	}
    }

    private void printMultipartMessage(String folder, int msgNum, Multipart mp,
	    PrintWriter out) throws MessagingException, IOException {
	for (int i = 0; i < mp.getCount(); i++) {
	    Object content = mp.getBodyPart(i).getContent();
	    if (content instanceof String) {
		out.println((String) content);
	    } else if (content instanceof Multipart) {
		Multipart mpt = (Multipart) content;
		printMultipartMessage(folder, msgNum, mpt, out);
	    } else {
		// generate a url for this part
		Part part = mp.getBodyPart(i);
		int partNum = i;
		String s;
		if ((s = part.getFileName()) != null)
		    out.println("<p><b>Filename:</b> " + s + "");
		out.println("<a href=\"" + "?message=" + msgNum + "&amp;part="
			+ partNum + "&amp;folder=" + folder
			+ "\">Download</a></p>");
	    }
	}
    }

    private String printFolders(StringBuilder sb, Folder f)
	    throws MessagingException {
	if (f.list().length != 0) {
	    Folder[] zoznam = f.list();
	    if (!f.getName().equals(""))
		sb.append("<span class=\"folderHeading\">" + f.getFullName()
			+ "</span>");
	    sb.append("<ul>");
	    for (int i = 0; i < zoznam.length; i++) {
		sb.append(printFolders(new StringBuilder(), zoznam[i]));
	    }
	    sb.append("</ul>");
	} else {
	    sb.append("<li><a href=\"?folder=" + f.getFullName() + "\">"
		    + f.getName() + "</a></li>");
	}
	return sb.toString();
    }

    private void printFooter(PrintWriter out) {
	out.print("</body></html>");
    }

    private void printHeader(PrintWriter out) {
	out.print("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" "
		+ "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	out
		.print("<html xmlns=\"http://www.w3.org/1999/xhtml\">"
			+ "<head>"
			+ "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />"
			+ "<title>JavaMail Servlet</title>"
			+ "<meta name=\"author\" content=\"Pavol Rajzák\"/>"
			+ "<link href=\"style.css\" rel=\"stylesheet\" type=\"text/css\" />"
			+ "</head><body>");

    }

    /**
     * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
     *      response)
     */
    protected void doPost(HttpServletRequest request,
	    HttpServletResponse response) throws ServletException, IOException {
	HttpSession registeredSession = request.getSession(true);
	registeredSession.setMaxInactiveInterval(1000000);

	String recepient = null;
	if (request.getParameter("recepient") != null)
	    recepient = request.getParameter("recepient");

	String subject = null;
	if (request.getParameter("subject") != null)
	    subject = request.getParameter("subject");

	String text = null;
	if (request.getParameter("text") != null)
	    text = request.getParameter("text");

	String userName = null;
	if (request.getParameter("userName") != null) {
	    userName = request.getParameter("userName");
	    registeredSession.setAttribute("userName", userName);
	} else {
	    userName = (String) registeredSession.getAttribute("userName");
	}

	String userPassword = null;
	if (request.getParameter("userPassword") != null) {
	    userPassword = request.getParameter("userPassword");
	    registeredSession.setAttribute("userPassword", userPassword);
	} else {
	    userPassword = (String) registeredSession
		    .getAttribute("userPassword");
	}

	String userAddress = userName + "@gmail.com";
	registeredSession.setAttribute("userAddress", userAddress);

	if (recepient != null && subject != null && text != null) {

	    Properties props = new Properties();
	    props.put("mail.smtp.host", "smtp.gmail.com");
	    props.put("mail.smtp.port", "587");
	    props.put("mail.debug", "true");
	    props.put("mail.smtp.auth", "true");
	    props.put("mail.smtp.starttls.enable", "true");

	    Session s = Session.getInstance(props, null);
	    s.setDebug(true);

	    MimeMessage message = new MimeMessage(s);

	    InternetAddress from = new InternetAddress(userAddress, userName);
	    InternetAddress to;
	    try {
		to = new InternetAddress(recepient);
		message.setSentDate(new Date());
		message.setFrom(from);
		message.addRecipient(Message.RecipientType.TO, to);

		message.setSubject(subject, "utf-8");
		message.setText(text, "utf-8");

		Transport tr = s.getTransport("smtps");
		tr.connect("smtp.gmail.com", userAddress, userPassword);
		message.saveChanges();
		tr.sendMessage(message, message.getAllRecipients());
		tr.close();
	    } catch (Exception e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }

	}

	doGet(request, response);
    }

}
